package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLIDtoIDMap_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLIDtoIDMap extends JNIObject  {
	
	/* @generated */
	protected ISLIDtoIDMap(long ptr) {
		/*** PROTECTED REGION ID(ISLIDtoIDMap_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLIDtoIDMap build(long ptr) {
		return new ISLIDtoIDMap(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLIDtoIDMap_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_id_to_id_alloc 
	 * 
	 * @generated
	**/
	 public static ISLIDtoIDMap alloc(ISLContext ctx, int min_size) { 
		/*** PROTECTED REGION ID(static_isl_id_to_id_alloc) DISABLED START ***/
		ISLIDtoIDMap res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLIDtoIDMap.build(ISLNative.isl_id_to_id_alloc(getNativePtr(ctx), min_size));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_id_to_id_to_string 
	 * 
	 * @generated
	**/
	 public static String _toString(ISLIDtoIDMap id2id, int format) { 
		/*** PROTECTED REGION ID(static_isl_id_to_id_to_string) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_id_to_id_to_string(getNativePtr(id2id), format);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_id_to_id_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_id_to_id_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_id_to_id_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_id_to_id_copy 
	 * 
	 * @generated
	**/
	public ISLIDtoIDMap copy() {
		/*** PROTECTED REGION ID(isl_id_to_id_copy) DISABLED START ***/
		ISLIDtoIDMap res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLIDtoIDMap.build(ISLNative.isl_id_to_id_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_id_to_id_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_id_to_id_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_id_to_id_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_id_to_id_has 
	 * 
	 * @generated
	**/
	public boolean containsKey(ISLIdentifier key) {
		/*** PROTECTED REGION ID(isl_id_to_id_has) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_id_to_id_has(getNativePtr(this), getNativePtr(key)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_id_to_id_get 
	 * 
	 * @take key
	 * @generated
	**/
	public ISLIdentifier get(ISLIdentifier key) {
		/*** PROTECTED REGION ID(isl_id_to_id_get) DISABLED START ***/
		ISLIdentifier res;
		
		synchronized(LOCK) {
			checkParameters(key);
			try {
				res = ISLIdentifier.build(ISLNative.isl_id_to_id_get(getNativePtr(this), getNativePtr(key)));
			} finally {
				taken(key);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_id_to_id_set 
	 * 
	 * @take this key val
	 * @generated
	**/
	public ISLIDtoIDMap put(ISLIdentifier key, ISLIdentifier val) {
		/*** PROTECTED REGION ID(isl_id_to_id_set) DISABLED START ***/
		ISLIDtoIDMap res;
		
		synchronized(LOCK) {
			checkParameters(this, key, val);
			try {
				res = ISLIDtoIDMap.build(ISLNative.isl_id_to_id_set(getNativePtr(this), getNativePtr(key), getNativePtr(val)));
			} finally {
				taken(this);
				taken(key);
				taken(val);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_id_to_id_drop 
	 * 
	 * @take this key
	 * @generated
	**/
	public ISLIDtoIDMap remove(ISLIdentifier key) {
		/*** PROTECTED REGION ID(isl_id_to_id_drop) DISABLED START ***/
		ISLIDtoIDMap res;
		
		synchronized(LOCK) {
			checkParameters(this, key);
			try {
				res = ISLIDtoIDMap.build(ISLNative.isl_id_to_id_drop(getNativePtr(this), getNativePtr(key)));
			} finally {
				taken(this);
				taken(key);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLIDtoIDMap_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
